mod Ex02c

incl Mtex

incl Mauxc

loc rem 
  2. CVICENIE Z PREDMETU TEORIA VYPOCITATELNOSTI PRE PROGRAMATOROV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 29.9.2005
  ******************************************************************************
  PMAIL: comp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/comp
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
  ULOHY: 20%
  MIDTERM: 20%
  FINALTERM: 60%
  ******************************************************************************
  POCET BODOV ZA ULOHY V TOMTO SUBORE: 1
  POCET BODOV ZA PREMIOVE ULOHY V TOMTO SUBORE: 1
  ******************************************************************************
  PRENOS: <cl>/4i/prenos/ex/ex02/<vase meno>/ex02.cl
          kde <cl> je adresar /data/VYUKA/INF/CL na barbie.nw.fmph.uniba.sk
          ************************************************
          *** odovzdat do 4.10.2005 (utorok) do 18:00 ***
          ************************************************
  ******************************************************************************

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie niektorych funkcii 
         a predikatov. 
   \item \para Subory \it  ex02*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Pairing Function.  \end See the module \ft Mauxc \end. 

rem 
  \para \bf  Subsection. Course of Values Recursion.  \end 

rem 
  \para \bf  [CL] Remark.  \end Do not use the `function' \ft D \end from the 
  module \it  Standard  \end; it plays the role of if-then-else construct. Use 
  rather the function \ft D1(x,y,z) \end defined in the module \it  Mauxc  \end 
  with prefix name \it  D1  \end. 

rem 
  \para \bf  Course of values functions.  \end In the following examples use the 
  method of course values sequences to show that the functions discussed are 
  primitive recursive. 

rem 
  \para \bf  Exercise.  \end \header* fun Fib 'Tex_f1_pa_fib' \end \it  [Uloha 
  (1 bod)]  \end The Fibonacci function \ft Fib(n) \end has the following course 
  of values recursive definition: 

fun Fib 'Tex_f1_pa_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

rem 
  \para Show that the function is primitive recursive. 

fun Cvf_fib_debug 'Tex_f1_comp_cvf_f'
  Cvf_fib_debug(0) = 0,0
  Cvf_fib_debug(n+1) = Fib(n+1),Cvf_fib_debug(n)

fun Cvf_fib 'Tex_f1_comp_cvf_f'
  Cvf_fib(n) = Foo

fun Fib1 'Tex_f1_pa_fib'
  Fib1(n) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end The list 
  concatenation function \ft x++y \end has the following course of values 
  recursive definition: 

fun/2 Conc 'Tex_f2_ln_conc'
  Conc(0,y) = y
  Conc((v,w),y) = v,Conc(w,y)

rem 
  \para Show that the function is primitive recursive. 

fun/2 Cvf_conc_debug 'Tex_f2_comp_cvf_f'
  Cvf_conc_debug(0,y) = y,0
  Cvf_conc_debug(x+1,y) = x+1++y,Cvf_conc_debug(x,y)

fun/2 Cvf_conc 'Tex_f2_comp_cvf_f'
  Cvf_conc(x,y) = Foo

fun/2 Conc1 'Tex_f2_ln_conc'
  Conc1(x,y) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

